/*     */ package org.hibernate.ejb;
/*     */ 
/*     */ import java.beans.BeanInfo;
/*     */ import java.beans.Introspector;
/*     */ import java.beans.PropertyDescriptor;
/*     */ import java.lang.reflect.Array;
/*     */ import java.lang.reflect.Method;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Enumeration;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Properties;
/*     */ import java.util.StringTokenizer;
/*     */ import org.hibernate.HibernateException;
/*     */ import org.hibernate.MappingException;
/*     */ import org.hibernate.annotations.common.reflection.ReflectionManager;
/*     */ import org.hibernate.cfg.AnnotationConfiguration;
/*     */ import org.hibernate.ejb.event.CallbackHandlerConsumer;
/*     */ import org.hibernate.ejb.event.EJB3AutoFlushEventListener;
/*     */ import org.hibernate.ejb.event.EJB3DeleteEventListener;
/*     */ import org.hibernate.ejb.event.EJB3FlushEntityEventListener;
/*     */ import org.hibernate.ejb.event.EJB3FlushEventListener;
/*     */ import org.hibernate.ejb.event.EJB3MergeEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PersistEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PersistOnFlushEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PostDeleteEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PostInsertEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PostLoadEventListener;
/*     */ import org.hibernate.ejb.event.EJB3PostUpdateEventListener;
/*     */ import org.hibernate.ejb.event.EJB3SaveEventListener;
/*     */ import org.hibernate.ejb.event.EJB3SaveOrUpdateEventListener;
/*     */ import org.hibernate.ejb.event.EntityCallbackHandler;
/*     */ import org.hibernate.event.AutoFlushEventListener;
/*     */ import org.hibernate.event.DeleteEventListener;
/*     */ import org.hibernate.event.EventListeners;
/*     */ import org.hibernate.event.FlushEntityEventListener;
/*     */ import org.hibernate.event.FlushEventListener;
/*     */ import org.hibernate.event.MergeEventListener;
/*     */ import org.hibernate.event.PersistEventListener;
/*     */ import org.hibernate.event.PostDeleteEventListener;
/*     */ import org.hibernate.event.PostInsertEventListener;
/*     */ import org.hibernate.event.PostLoadEventListener;
/*     */ import org.hibernate.event.PostUpdateEventListener;
/*     */ import org.hibernate.event.PreDeleteEventListener;
/*     */ import org.hibernate.event.PreInsertEventListener;
/*     */ import org.hibernate.event.PreLoadEventListener;
/*     */ import org.hibernate.event.PreUpdateEventListener;
/*     */ import org.hibernate.event.SaveOrUpdateEventListener;
/*     */ import org.hibernate.event.def.DefaultPostLoadEventListener;
/*     */ import org.hibernate.event.def.DefaultPreLoadEventListener;
/*     */ import org.hibernate.mapping.PersistentClass;
/*     */ import org.hibernate.secure.JACCPreDeleteEventListener;
/*     */ import org.hibernate.secure.JACCPreInsertEventListener;
/*     */ import org.hibernate.secure.JACCPreLoadEventListener;
/*     */ import org.hibernate.secure.JACCPreUpdateEventListener;
/*     */ import org.hibernate.secure.JACCSecurityListener;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class EventListenerConfigurator
/*     */ {
/*  62 */   private static final Object[] READER_METHOD_ARGS = new Object[0];
/*     */   private Ejb3Configuration configuration;
/*     */   private boolean isSecurity;
/*     */   
/*     */   public EventListenerConfigurator(Ejb3Configuration configuration)
/*     */   {
/*  68 */     this.configuration = configuration;
/*  69 */     EventListeners listenerConfig = configuration.getEventListeners();
/*     */     
/*     */ 
/*     */ 
/*  73 */     listenerConfig.setFlushEventListeners(new FlushEventListener[] { EJB3FlushEventListener.INSTANCE });
/*     */     
/*  75 */     listenerConfig.setAutoFlushEventListeners(new AutoFlushEventListener[] { EJB3AutoFlushEventListener.INSTANCE });
/*  76 */     listenerConfig.setDeleteEventListeners(new DeleteEventListener[] { new EJB3DeleteEventListener() });
/*  77 */     listenerConfig.setFlushEntityEventListeners(new FlushEntityEventListener[] { new EJB3FlushEntityEventListener() });
/*     */     
/*     */ 
/*  80 */     listenerConfig.setMergeEventListeners(new MergeEventListener[] { new EJB3MergeEventListener() });
/*  81 */     listenerConfig.setPersistEventListeners(new PersistEventListener[] { new EJB3PersistEventListener() });
/*  82 */     listenerConfig.setPersistOnFlushEventListeners(new PersistEventListener[] { new EJB3PersistOnFlushEventListener() });
/*     */     
/*     */ 
/*  85 */     listenerConfig.setSaveEventListeners(new SaveOrUpdateEventListener[] { new EJB3SaveEventListener() });
/*  86 */     listenerConfig.setSaveOrUpdateEventListeners(new SaveOrUpdateEventListener[] { new EJB3SaveOrUpdateEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*  91 */     listenerConfig.setPreInsertEventListeners(new PreInsertEventListener[] { new JACCPreInsertEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*  96 */     listenerConfig.setPreUpdateEventListeners(new PreUpdateEventListener[] { new JACCPreUpdateEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 101 */     listenerConfig.setPreDeleteEventListeners(new PreDeleteEventListener[] { new JACCPreDeleteEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 110 */     listenerConfig.setPreLoadEventListeners(new PreLoadEventListener[] { new DefaultPreLoadEventListener(), new JACCPreLoadEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 118 */     listenerConfig.setPostDeleteEventListeners(new PostDeleteEventListener[] { new EJB3PostDeleteEventListener() });
/*     */     
/*     */ 
/* 121 */     listenerConfig.setPostInsertEventListeners(new PostInsertEventListener[] { new EJB3PostInsertEventListener() });
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 127 */     listenerConfig.setPostLoadEventListeners(new PostLoadEventListener[] { new EJB3PostLoadEventListener(), new DefaultPostLoadEventListener() });
/*     */     
/*     */ 
/* 130 */     listenerConfig.setPostUpdateEventListeners(new PostUpdateEventListener[] { new EJB3PostUpdateEventListener() });
/*     */   }
/*     */   
/*     */ 
/*     */   public void setProperties(Properties properties)
/*     */   {
/* 136 */     if (properties.containsKey("hibernate.jacc.enabled")) {
/* 137 */       this.isSecurity = true;
/*     */     }
/*     */     
/* 140 */     Enumeration<?> enumeration = properties.propertyNames();
/* 141 */     while (enumeration.hasMoreElements()) {
/* 142 */       String name = (String)enumeration.nextElement();
/* 143 */       if (name.startsWith("hibernate.ejb.event")) {
/* 144 */         String type = name.substring("hibernate.ejb.event".length() + 1);
/* 145 */         StringTokenizer st = new StringTokenizer(properties.getProperty(name), " ,", false);
/* 146 */         List<String> listeners = new ArrayList();
/* 147 */         while (st.hasMoreElements()) {
/* 148 */           listeners.add((String)st.nextElement());
/*     */         }
/* 150 */         this.configuration.setListeners(type, (String[])listeners.toArray(new String[listeners.size()]));
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public void configure()
/*     */   {
/* 158 */     EntityCallbackHandler callbackHandler = new EntityCallbackHandler();
/* 159 */     this.configuration.buildMappings();
/* 160 */     Iterator classes = this.configuration.getClassMappings();
/* 161 */     ReflectionManager reflectionManager = this.configuration.getHibernateConfiguration().getReflectionManager();
/* 162 */     while (classes.hasNext()) {
/* 163 */       PersistentClass clazz = (PersistentClass)classes.next();
/* 164 */       if (clazz.getClassName() != null) {
/*     */         try
/*     */         {
/* 167 */           callbackHandler.add(reflectionManager.classForName(clazz.getClassName(), getClass()), reflectionManager);
/*     */         }
/*     */         catch (ClassNotFoundException e) {
/* 170 */           throw new MappingException("entity class not found: " + clazz.getNodeName(), e);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 175 */     EventListeners listenerConfig = this.configuration.getEventListeners();
/*     */     
/* 177 */     BeanInfo beanInfo = null;
/*     */     try {
/* 179 */       beanInfo = Introspector.getBeanInfo(listenerConfig.getClass(), Object.class);
/* 180 */       PropertyDescriptor[] pds = beanInfo.getPropertyDescriptors();
/*     */       try {
/* 182 */         int i = 0; for (int max = pds.length; i < max; i++) {
/* 183 */           Object listeners = pds[i].getReadMethod().invoke(listenerConfig, READER_METHOD_ARGS);
/* 184 */           if (listeners == null) {
/* 185 */             throw new HibernateException("Listener [" + pds[i].getName() + "] was null");
/*     */           }
/* 187 */           if ((listeners instanceof Object[])) {
/* 188 */             int securityListenersNbr = 0;
/* 189 */             Object[] listenersArray = (Object[])listeners;
/* 190 */             for (Object listener : listenersArray) {
/* 191 */               if ((listener != null) && ((listener instanceof CallbackHandlerConsumer))) {
/* 192 */                 ((CallbackHandlerConsumer)listener).setCallbackHandler(callbackHandler);
/*     */               }
/* 194 */               if ((listener != null) && ((listener instanceof JACCSecurityListener)) && 
/* 195 */                 (!this.isSecurity)) {
/* 196 */                 securityListenersNbr++;
/*     */               }
/*     */             }
/*     */             
/* 200 */             if (!this.isSecurity) {
/* 201 */               Class clazz = pds[i].getReadMethod().getReturnType().getComponentType();
/* 202 */               Object newArray = Array.newInstance(clazz, listenersArray.length - securityListenersNbr);
/* 203 */               int index = 0;
/* 204 */               for (Object listener : listenersArray) {
/* 205 */                 if ((listener == null) || (!(listener instanceof JACCSecurityListener))) {
/* 206 */                   Array.set(newArray, index++, listener);
/*     */                 }
/*     */               }
/* 209 */               pds[i].getWriteMethod().invoke(listenerConfig, new Object[] { newArray });
/*     */             }
/*     */           }
/*     */         }
/*     */       }
/*     */       catch (HibernateException e) {
/* 215 */         throw e;
/*     */       }
/*     */       catch (Throwable t) {
/* 218 */         throw new HibernateException("Unable to validate listener config", t);
/*     */       }
/*     */     }
/*     */     catch (Exception t) {
/* 222 */       throw new HibernateException("Unable to copy listeners", t);
/*     */     }
/*     */     finally {
/* 225 */       if (beanInfo != null)
/*     */       {
/*     */ 
/* 228 */         Introspector.flushFromCaches(getClass());
/*     */       }
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-entitymanager-3.3.2.GA.jar!\org\hibernate\ejb\EventListenerConfigurator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */