/*     */ package org.hibernate.ejb.packaging;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.Iterator;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class XmlHelper
/*     */ {
/*     */   public static Iterator getChildrenByTagName(Element element, String tagName)
/*     */   {
/*  32 */     if (element == null) { return null;
/*     */     }
/*     */     
/*     */ 
/*  36 */     NodeList children = element.getChildNodes();
/*  37 */     ArrayList goodChildren = new ArrayList();
/*  38 */     for (int i = 0; i < children.getLength(); i++) {
/*  39 */       Node currentChild = children.item(i);
/*  40 */       if ((currentChild.getNodeType() == 1) && (((Element)currentChild).getTagName().equals(tagName)))
/*     */       {
/*  42 */         goodChildren.add((Element)currentChild);
/*     */       }
/*     */     }
/*  45 */     return goodChildren.iterator();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Element getUniqueChild(Element element, String tagName)
/*     */     throws Exception
/*     */   {
/*  60 */     Iterator goodChildren = getChildrenByTagName(element, tagName);
/*     */     
/*  62 */     if ((goodChildren != null) && (goodChildren.hasNext())) {
/*  63 */       Element child = (Element)goodChildren.next();
/*  64 */       if (goodChildren.hasNext()) {
/*  65 */         throw new Exception("expected only one " + tagName + " tag");
/*     */       }
/*     */       
/*  68 */       return child;
/*     */     }
/*     */     
/*  71 */     throw new Exception("expected one " + tagName + " tag");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Element getOptionalChild(Element element, String tagName)
/*     */     throws Exception
/*     */   {
/*  87 */     return getOptionalChild(element, tagName, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Element getOptionalChild(Element element, String tagName, Element defaultElement)
/*     */     throws Exception
/*     */   {
/* 107 */     Iterator goodChildren = getChildrenByTagName(element, tagName);
/*     */     
/* 109 */     if ((goodChildren != null) && (goodChildren.hasNext())) {
/* 110 */       Element child = (Element)goodChildren.next();
/* 111 */       if (goodChildren.hasNext()) {
/* 112 */         throw new Exception("expected only one " + tagName + " tag");
/*     */       }
/*     */       
/* 115 */       return child;
/*     */     }
/*     */     
/* 118 */     return defaultElement;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String getElementContent(Element element)
/*     */     throws Exception
/*     */   {
/* 130 */     return getElementContent(element, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String getElementContent(Element element, String defaultStr)
/*     */     throws Exception
/*     */   {
/* 142 */     if (element == null) {
/* 143 */       return defaultStr;
/*     */     }
/*     */     
/* 146 */     NodeList children = element.getChildNodes();
/* 147 */     StringBuilder result = new StringBuilder("");
/* 148 */     for (int i = 0; i < children.getLength(); i++) {
/* 149 */       if ((children.item(i).getNodeType() == 3) || (children.item(i).getNodeType() == 4))
/*     */       {
/* 151 */         result.append(children.item(i).getNodeValue());
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 157 */     return result.toString().trim();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String getUniqueChildContent(Element element, String tagName)
/*     */     throws Exception
/*     */   {
/* 172 */     return getElementContent(getUniqueChild(element, tagName));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String getOptionalChildContent(Element element, String tagName)
/*     */     throws Exception
/*     */   {
/* 187 */     return getElementContent(getOptionalChild(element, tagName));
/*     */   }
/*     */   
/*     */   public static boolean getOptionalChildBooleanContent(Element element, String name) throws Exception {
/* 191 */     Element child = getOptionalChild(element, name);
/* 192 */     if (child != null) {
/* 193 */       String value = getElementContent(child).toLowerCase();
/* 194 */       return (value.equals("true")) || (value.equals("yes"));
/*     */     }
/*     */     
/* 197 */     return false;
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-entitymanager-3.3.2.GA.jar!\org\hibernate\ejb\packaging\XmlHelper.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */