package com.netapp.myasup.reportRest.bean;

import java.util.ArrayList;
import java.util.List;

/**
 * Value Object used to store Risk Detail for a System Aggregate (Site,Group,Customer)
 * VO denotes distinct Risk and it contains a List of Systems affected by the distinct Risk
 * This VO is passed from Service Layer to Controller
 * @author Amal Mohan
 */

public class RiskDetailForAggregateVO {	

	public String riskID;
	private String firstOccurred; 
	//private Boolean isPublic;
	private String riskCategory; 
	//private String potentialImpact;
	//private String correctiveAction;
	//private String burtID;
	private String internalInfo; 
	private String severity; 
	private String moreInfo; 
	private String riskName;
	private String details;    
	private String sysSerialNo;
	private List<String> affectedSystems = new ArrayList<String>();
	
	public String getRiskID() {
		return riskID;
	}
	public void setRiskID(String riskID) {
		this.riskID = riskID;
	}
	
	public String getFirstOccurred() {
		return firstOccurred;
	}
	public void setFirstOccurred(String firstOccurred) {
		this.firstOccurred = firstOccurred;
	}
	/*public Boolean getIsPublic() {
		return isPublic;
	}
	public void setIsPublic(Boolean isPublic) {
		this.isPublic = isPublic;
	}
	public String getPotentialImpact() {
		return potentialImpact;
	}
	
	public void setPotentialImpact(String potentialImpact) {
		this.potentialImpact = potentialImpact;
	}
	public String getCorrectiveAction() {
		return correctiveAction;
	}
	public void setCorrectiveAction(String correctiveAction) {
		this.correctiveAction = correctiveAction;
	}
	public String getBurtID() {
		return burtID;
	}
	public void setBurtID(String burtID) {
		this.burtID = burtID;
	}*/
	public String getInternalInfo() {
		return internalInfo;
	}
	public void setInternalInfo(String internalInfo) {
		this.internalInfo = internalInfo;
	}
	public String getMoreInfo() {
		return moreInfo;
	}
	public void setMoreInfo(String moreInfo) {
		this.moreInfo = moreInfo;
	}
	
	public String getRiskCategory() {
		return riskCategory;
	}
	public void setRiskCategory(String riskCategory) {
		this.riskCategory = riskCategory;
	}
	public List<String> getAffectedSystems() {
		return affectedSystems;
	}

	public void setAffectedSystems(List<String> affectedSystems) {
		this.affectedSystems = affectedSystems;
	}

	
	
	public String getRiskName() {
		return riskName;
	}
	public String getSysSerialNo() {
		return sysSerialNo;
	}
	public void setSysSerialNo(String sysSerialNo) {
		this.sysSerialNo = sysSerialNo;
	}
	public void setRiskName(String riskName) {
		this.riskName = riskName;
	}
	public String getDetails() {
		return details;
	}
	public void setDetails(String details) {
		this.details = details;
	}
	public String getSeverity() {
		return severity;
	}
	public void setSeverity(String severity) {
		this.severity = severity;
	}
	public void addSystemToAffectedSystemList(String systemid){
		affectedSystems.add(systemid);
	}
	
	@Override
	public String toString() {
		return "RiskDetailForAggregateVO [riskCategory="
				+ riskCategory + ",   internalInfo=" + internalInfo + ", severity="
				+ severity + ", moreInfo=" + moreInfo + ", riskName="
				+ riskName + ", details=" + details
				+ ", sysSerialNo=" + sysSerialNo + "]";
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((riskID == null) ? 0 : riskID.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RiskDetailForAggregateVO other = (RiskDetailForAggregateVO) obj;
		if (riskID == null) {
			if (other.riskID != null)
				return false;
		} else if (!riskID.equals(other.riskID))
			return false;
		return true;
	}


}
