/*    */ package org.hibernate.cfg;
/*    */ 
/*    */ import java.util.Map;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.XProperty;
/*    */ import org.hibernate.cfg.annotations.EntityBinder;
/*    */ import org.hibernate.mapping.Collection;
/*    */ import org.hibernate.mapping.Component;
/*    */ import org.hibernate.mapping.Join;
/*    */ import org.hibernate.mapping.PersistentClass;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class PropertyHolderBuilder
/*    */ {
/*    */   public static PropertyHolder buildPropertyHolder(XClass clazzToProcess, PersistentClass persistentClass, EntityBinder entityBinder, ExtendedMappings mappings)
/*    */   {
/* 30 */     return new ClassPropertyHolder(persistentClass, clazzToProcess, entityBinder, mappings);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static PropertyHolder buildPropertyHolder(Component component, String path, PropertyData inferredData, PropertyHolder parent, ExtendedMappings mappings)
/*    */   {
/* 45 */     return new ComponentPropertyHolder(component, path, inferredData, parent, mappings);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static PropertyHolder buildPropertyHolder(Collection collection, String path, XClass clazzToProcess, XProperty property, PropertyHolder parentPropertyHolder, ExtendedMappings mappings)
/*    */   {
/* 55 */     return new CollectionPropertyHolder(collection, path, clazzToProcess, property, parentPropertyHolder, mappings);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static PropertyHolder buildPropertyHolder(PersistentClass persistentClass, Map<String, Join> joins, ExtendedMappings mappings)
/*    */   {
/* 65 */     return new ClassPropertyHolder(persistentClass, null, joins, mappings);
/*    */   }
/*    */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\PropertyHolderBuilder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */